# webcam-saver.py
# by Markus Gritsch (gritsch@iue.tuwien.ac.at)

"""Monitors a picture on the net for (and saves it in case of) any changes.

The location of the picture to observe and the interval between probing is
specified in the webcam-saver.ini file.  Further details are given there.
"""

import urllib, time, string, os

f = open('webcam-saver.ini')
camurl = string.strip(f.readline())
interval = int(f.readline())
f.close()

def diff(file1, file2):
    """diff(file1, file2) -> integer

    Returns 1 if file1 differs from file2.  1 is also returned if one file or
    both files are not found.  Use this function only for small files, because
    no optimisation is done so the whole files are read into the memory.
    """
    try:
        f1 = open(file1, 'rb')
    except IOError:
        return 1
    try:
        f2 = open(file2, 'rb')
    except IOError:
        f1.close()
        return 1
    im1 = f1.read()
    im2 = f2.read()
    f1.close()
    f2.close()
    if im1 != im2:
        return 1

print 'Everytime this program is started it begins counting from 0.'
i = 0
oldlocalfile = ''
while 1:
    recenttime = time.time()
    head, tail = os.path.split(camurl)
    root, ext = os.path.splitext(tail)
    localfile = root + '_' + string.zfill(i, 5) + ext
    try:
        urllib.urlretrieve(camurl, localfile)
    except:
        import sys
        type, value = sys.exc_info()[:2]
        print 'webcam-saver.py: ' + str(type) + ':', value
    if diff(oldlocalfile, localfile):
        oldlocalfile = localfile
        i = i + 1
    else:
        pass
        os.remove(localfile)
    while time.time() - recenttime < interval:
        time.sleep(1)
